(document:surround "/std/frame")
(document:insert "/std/functions")
(po-domain "alterator-net-wifi")

(define *iface* (global 'iface))

;;;; UI

(groupbox (_ "Configured networks") align "top"

  (gridbox columns "40;60"

    (listbox name "networks" header (string-append (_ "Name") " [SSID]") (when selected (act-reset)))
    (gridbox columns "0;100"

      (spacer)
      (label name "current" text (bold (_ "Current network")) visibility #f)

      (label (string-append (_ "Name") ":") nameref "name")
      (edit name "name")

      (label (_ "Network name:") nameref "essid")
      (edit name "essid")

      (label (_ "Auth type:") nameref "auth_type")
      (combobox name "auth_type")

      (label (_ "Change password:") nameref "key")
      (edit "" name "key" echo "stars")

      ; (spacer)
      ; (checkbox text (_ "Autoconnect") name "autoconnect")

      (spacer)
      (gridbox columns "100;0;0;0" (spacer)
        (button text (_ "Apply") (when clicked (act-apply)))
        (button text (_ "Reset") (when clicked (act-reset)))
        (button text (_ "Delete") (when clicked (act-del)))
      )
    )
    (gridbox columns "50;50"
    (button text (_ "Connect") (when clicked (act-connect)))
    (button text (_ "Disconnect") (when clicked (act-disconnect)))
    )
    (spacer)
  )
)

(label (string-append "<b>" (_ "Configure new network") "</b>"))


(gridbox columns "0;90;10;0" align "top"
  (label) (label (string-append (_ "Name") " / " (_ "signal") " / MAC" )) (label) (label)
  (label (_ "Networks found:"))
  (combobox name "scan-results")
  (button text (_ "Rescan") (when clicked (act-scan)))
  (button text (_ "Configure") (when clicked (act-new))))

(button (_ "OK")
  align "left"
  (when clicked
    (document:end)))


;;;; LOGIC

(define (act-new)
  (woo-write "/net-wifi-nm/new"
    'iface *iface*
    'name     (form-value "scan-results")
  )
  (update-ui)
)

(define (act-reset)
    (let ((data
      (woo-read-first "/net-wifi-nm" 'iface *iface* 'uuid (form-value "networks"))))
      (form-update-visibility "current"   (woo-get-option data 'current))
      (form-update-value "name"     (woo-get-option data 'name ""))
      (form-update-value "essid"     (woo-get-option data 'essid ""))
      (form-update-value "auth_type" (woo-get-option data 'auth_type))
      ; (form-update-value "autoconnect" (woo-get-option data 'autoconnect))
      (form-update-value "key"       (woo-get-option data 'key)) )
)


(define (act-save doconnect)
  (catch/message
    (lambda()
  (woo-write "/net-wifi-nm/save"
      'iface *iface*
      'uuid      (form-value "networks")
      'name      (form-value "name")
      'essid     (form-value "essid")
      'auth_type (form-value "auth_type")
      ; 'autoconnect (form-value "autoconnect")
      'key       (form-value "key")
      'connect doconnect)
  ))
)
;;;

(define (act-apply)
  (act-save #f)
  (update-ui)
  (act-reset)
)

(define (act-connect)
  (act-save #t)
  (update-ui)
  (act-reset)
)

(define (act-disconnect)
  (woo-write "/net-wifi-nm/disconnect" 'iface *iface* 'uuid (form-value "networks"))
  (update-ui)
  (act-reset)
)

(define (act-del)
  (woo-write "/net-wifi-nm/remove" 'iface *iface* 'uuid (form-value "networks"))
  (update-ui)
  (act-reset)
)

(define (act-scan)
    (form-update-enum "scan-results" (woo-list "/net-wifi-nm/scan" 'iface *iface*))
)

(define (update-ui)
  (form-update-enum "networks" (woo-list "/net-wifi-nm/networks" 'iface *iface*))
  (form-update-enum "auth_type" (woo-list "/net-wifi-nm/auth_types" 'iface *iface*))
)

(document:root 
  (when loaded
    (act-scan)
    (update-ui)
  )
)
